--Put here variables that should NOT be reset on level passing or level restarting
self.colormode = 1

--These functions must have the EXACT same name from the lua file
function ExampleGame_load()
	--Whenever the game restarts this variable will be reset
	self.x = 1
	self.y = 1
	self.dir = 0
	self.color1 = self.colormode
	self.color2 = 1-self.colormode
end

function ExampleGame_update(dt)
	--The speed depends on the pre-set game speed
	--So if the game speed is 10, dt will be dt*10 by default
	
	self.x = self.x+dt*self.dir*4
	while self.x >= 33 do
		self.x = self.x - 32
	end
	while self.x < 1 do
		self.x = self.x + 32
	end
end

--[[All the drawing functions (so far):
	
	minigame.draw(imagedata, x, y)
	minigame.point(x, y)
	minigame.rectangle("fill" or "line", x, y, width, height)
	minigame.print(string, x ,y)
	minigame.setColor(0, 0.2, 0.4, 0.6, 0.8 or 1)
	minigame.setBackground(0, 0.2, 0.4, 0.6, 0.8, 1)
	
	minigame.setScissor(x, y, width, height)
	minigame.translate(x, y)
]]
function ExampleGame_draw()
	minigame.setBackground(self.color2)
	minigame.setColor(self.color1)
	minigame.point(math.floor(self.x), self.y)
end

--[[All the buttons (so far):
	
	"R", "L", "U", "D": right, left, up and down
	"B": Big button/Action button
	"P": Pause button
]]
function ExampleGame_buttonPressed(button)
	if button == "D" then
		self.y = self.y + 1
		if self.y > 32 then
			self.y = 1
		end
	elseif button == "U" then
		self.y = self.y - 1
		if self.y < 1 then
			self.y = 32
		end
	elseif button == "B" then
		self.colormode = 1-self.colormode
		self.color1 = self.colormode
		self.color2 = 1-self.colormode
	end
	
	if button == "L" and not minigame.buttonDown("R") then
		self.dir = -1
	end
	if button == "R" and not minigame.buttonDown("L") then
		self.dir = 1
	end
end

function ExampleGame_buttonReleased(button)
	if button == "L" and not minigame.buttonDown("R") then
		self.dir = 0
	end
	if button == "R" and not minigame.buttonDown("L") then
		self.dir = 0
	end
end

--[[All the game-related functions (so far):
	
	minigame.setLives(number)
	minigame.addLives(number)
	minigame.removeLives(number)
	
	minigame.gameOver() (automatically called when you have 0 lives)
	
	minigame.setScore(number) (must be a multiple of 100)
	minigame.addScore(number)
	minigame.removeScore(number)
	
	minigame.resetLevel()
	minigame.levelUp() (goes to level 1 if passed of level 10)
	
	minigame.buttonDown(button) (see list of buttons)
]]

--[[All the data-managing new functions (so far):
	
	table.copy(table)
	table.contains(table, entry)
	round(number, decimal digits)
	string.split(string, delimiter)
]]